import { Checkout, UserError } from '../types';
import { CheckoutState } from './useCheckout';
export declare const STARTED_REQUEST = "STARTED_REQUEST";
export declare const FETCHED_CHECKOUT = "FETCHED_CHECKOUT";
export declare const CREATED_CHECKOUT = "CREATED_CHECKOUT";
export declare const APPLIED_DISCOUNT = "APPLIED_DISCOUNT";
export declare const REMOVED_DISCOUNT = "REMOVED_DISCOUNT";
export declare const ADDED_LINE_ITEMS = "ADDED_LINE_ITEMS";
export declare const UPDATED_LINE_ITEMS = "UPDATED_LINE_ITEMS";
export declare const RECEIVED_ERRORS = "RECEIVED_ERRORS";
export declare const CART_CLEARED = "RECEIVED_ERRORS";
interface StartedAction {
    type: typeof STARTED_REQUEST;
}
interface GenericAction {
    type: typeof FETCHED_CHECKOUT | typeof CREATED_CHECKOUT | typeof APPLIED_DISCOUNT | typeof REMOVED_DISCOUNT | typeof ADDED_LINE_ITEMS | typeof UPDATED_LINE_ITEMS | typeof RECEIVED_ERRORS | typeof CART_CLEARED;
    checkout?: Checkout;
    checkoutUserErrors?: UserError[];
}
export declare type CheckoutAction = StartedAction | GenericAction;
export declare const reducer: (state: CheckoutState, action: CheckoutAction) => CheckoutState;
export {};
