import { Paginated } from '@good-idea/unwind-edges';
import { MaybeAll, Variant as SourceVariant, Maybe } from '../types';
interface Options {
    initialVariant?: string | 'first' | 'last';
}
interface Variant extends Pick<SourceVariant, 'id' | 'title' | 'selectedOptions'> {
    __typename: any;
}
export interface UseProductVariant {
    currentVariant?: Variant;
    selectVariant: (variantId: string) => void;
}
interface Product<V> {
    title?: Maybe<string>;
    variants?: Maybe<Paginated<Maybe<V>>>;
}
interface ReturnValue<V> {
    currentVariant: V | null;
    selectVariant: (id: string) => void;
}
export declare const useProductVariant: <V extends MaybeAll<Variant>>(product: MaybeAll<Product<V>>, options?: Options) => ReturnValue<V>;
export {};
